
from libcpp.string cimport string
from array cimport cpp_MArray

cdef extern from "cereal/cnorxz_cereal.h" namespace "CNORXZ::cer":
    cdef cppclass cpp_Format "CNORXZ::cer::Format":
        pass

cdef extern from "cereal/cnorxz_cereal.h" namespace "CNORXZ::cer::Format":
    cdef cpp_Format BINARY
    cdef cpp_Format JSON
    cdef cpp_Format XML

cdef extern from "cereal/cnorxz_cereal.h" namespace "CNORXZ::cer":
    cdef void cpp_writeJSONFile "CNORXZ::cer::writeJSONFile" [T] (const string&, const cpp_MArray[T]&)

cdef extern from "cereal/cnorxz_cereal.h" namespace "CNORXZ::cer":
    cdef void cpp_writeBINARYFile "CNORXZ::cer::writeBINARYFile" [T] (const string&, const cpp_MArray[T]&)

cdef extern from "cereal/cnorxz_cereal.h" namespace "CNORXZ::cer":
    cdef void cpp_readJSONFile "CNORXZ::cer::readJSONFile" [T] (const string&, cpp_MArray[T]&)

cdef extern from "cereal/cnorxz_cereal.h" namespace "CNORXZ::cer":
    cdef void cpp_readBINARYFile "CNORXZ::cer::readBINARYFile" [T] (const string&, cpp_MArray[T]&)
