
from libcpp.memory cimport shared_ptr
from libcpp.string cimport string
from range cimport cpp_RangeBase


cdef extern from "ranges/ranges.h" namespace "CNORXZ":
    cdef cppclass cpp_DIndex "CNORXZ::DIndex":
        cpp_DIndex() except+
        cpp_DIndex(const cpp_DIndex&) except+
        cpp_DIndex(const shared_ptr[cpp_RangeBase]&, size_t lexpos) except+
        cpp_DIndex setlpos "operator=" (size_t n) except+
        cpp_DIndex setincr "operator++"() except+
        cpp_DIndex setdecr "operator--"() except+
        cpp_DIndex plus "operator+"(int n) except+
        cpp_DIndex minus "operator-"(int n) except+

        size_t lex() except+
        size_t dim() except+

        shared_ptr[cpp_RangeBase] range() except+

        string stringMeta() except+


cdef extern from "ranges/ranges.h" namespace "CNORXZ":
    cdef cppclass cpp_YIndex "CNORXZ::YIndex":
        cpp_YIndex() except+
        cpp_YIndex(const cpp_YIndex&) except+
        cpp_YIndex(const shared_ptr[cpp_RangeBase]&, size_t lexpos) except+
        
        cpp_YIndex setlpos "operator=" (size_t n) except+
        cpp_YIndex setincr "operator++"() except+
        cpp_YIndex setdecr "operator--"() except+
        cpp_YIndex plus "operator+"(int n) except+
        cpp_YIndex minus "operator-"(int n) except+

        size_t lex() except+
        size_t dim() except+

        shared_ptr[cpp_RangeBase] range() except+

        string stringMeta() except+
        
